uniform sampler2D texture;
uniform float blur_radius;

void main()
{
    // vec2 offx = vec2(blur_radius, 0.0);
    // vec2 offy = vec2(0.0, blur_radius);

    // vec4 pixel = texture2D(texture, gl_TexCoord[0].xy)               * 4.0 +
    //              texture2D(texture, gl_TexCoord[0].xy - offx)        * 2.0 +
    //              texture2D(texture, gl_TexCoord[0].xy + offx)        * 2.0 +
    //              texture2D(texture, gl_TexCoord[0].xy - offy)        * 2.0 +
    //              texture2D(texture, gl_TexCoord[0].xy + offy)        * 2.0 +
    //              texture2D(texture, gl_TexCoord[0].xy - offx - offy) * 1.0 +
    //              texture2D(texture, gl_TexCoord[0].xy - offx + offy) * 1.0 +
    //              texture2D(texture, gl_TexCoord[0].xy + offx - offy) * 1.0 +
    //              texture2D(texture, gl_TexCoord[0].xy + offx + offy) * 1.0;

    // gl_FragColor =  gl_Color * (pixel / 16.0);





    float Pi = 6.28318530718; // Pi*2
    
    // GAUSSIAN BLUR SETTINGS {{{
    float Directions = 8.0; // BLUR DIRECTIONS (Default 16.0 - More is better but slower)
    float Quality = 4.0; // BLUR QUALITY (Default 4.0 - More is better but slower)
    // GAUSSIAN BLUR SETTINGS }}}
   
    vec2 uv = gl_TexCoord[0].xy;

    // Pixel colour
    vec4 Color = texture2D(texture, uv);
    
    // Blur calculations
    for( float d=0.0; d<Pi; d+=Pi/Directions)
    {
		for(float i=1.0/Quality; i<=1.0; i+=1.0/Quality)
        {
			Color += texture2D( texture, uv+vec2(cos(d),sin(d))*blur_radius*i);		
        }
    }
    
    // Output to screen
    Color /= (Quality * Directions);
    gl_FragColor =  gl_Color * Color;
}