uniform sampler2D texture;
uniform float time;

float random(vec2 st) {
    return fract(sin(dot(st.xy, vec2(12.9898,78.233))) * 43758.5453123);
}

void main()
{
    vec2 uv = gl_TexCoord[0].xy;

    // Generate random offset using the UV coordinates and time
    float offsetWhole = random(vec2(1,1) * float(int(time*15.))/15.) * 0.005;
    float offset = random(uv * float(int(time*15.))/15.) * 0.005;

    uv += offsetWhole;
    uv += vec2(offset,offset);

    // Sample the texture at the displaced UV coordinates
    vec4 color = texture2D(texture, uv);

    // Introduce color shifts
    float r = texture2D(texture, uv + vec2(random(uv * time + vec2(2.0)) * 0.02, 0.0)).r;
    float g = color.g;
    float b = texture2D(texture, uv + vec2(-random(uv * time + vec2(3.0)) * 0.02, 0.0)).b;

    // Combine the color channels
    color = vec4(r, g, b, color.a);

    // Output the final color
    gl_FragColor = color;
}
