uniform sampler2D texture;
uniform float time;

void main()
{

    // Sample the texture at the modified UV coordinates
    vec4 color = texture2D(texture, gl_TexCoord[0].xy);
    
    
    vec2 uv = gl_TexCoord[0].xy;

    uv.x += sin(uv.y * 10.0 + time) * 0.1;
    uv.y += cos(uv.x * 10.0 + time) * 0.1;

    // Generate a color based on UV coordinates and time
    vec3 multicolor = vec3(
        0.5 + 0.5 * sin(time*2.0 + uv.x * 10.0),
        0.5 + 0.5 * sin(time*2.0 + uv.y * 10.0),
        0.5 + 0.5 * sin(time*2.0 + uv.x * 10.0 + uv.y * 10.0)
    );

    // Mix the texture color with the multicolor effect
    gl_FragColor = vec4(color.rgb * multicolor, color.a);
}